/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if_ed.h,v 1.5 2009/12/24 05:46:31 abe Exp abe $
 */

/*
 * Copyright (C) 1993, David Greenman. This software may be used, modified,
 *   copied, distributed, and sold, in both source and binary form provided
 *   that the above copyright and these terms are retained. Under no
 *   circumstances is the author responsible for the proper functioning
 *   of this software, nor does the author assume any responsibility
 *   for damages incurred with its use.
 */

#ifndef _IF_ED_H_
#define _IF_ED_H_

/*
 *  NIC ޥ
 */

#define IF_ETHER_NIC_GET_SOFTC()	ed_get_softc()
#define IF_ETHER_NIC_WATCHDOG(i)	ed_watchdog(i)
#define IF_ETHER_NIC_PROBE(i)		ed_probe(i)
#define IF_ETHER_NIC_INIT(i)		ed_init(i)
#define IF_ETHER_NIC_READ(i)		ed_read(i)
#define IF_ETHER_NIC_RESET(i)		ed_reset(i)
#define IF_ETHER_NIC_START(i,o)		ed_start(i,o)

#define T_IF_ETHER_NIC_SOFTC		struct t_ed_softc

/* IPv6 ط */

#define IF_ETHER_NIC_IN6_IFID(i,a)	get_mac6_ifid(i,a)	/* 󥿥ե̻Ҥ		*/
#define IF_ETHER_NIC_ADDMULTI(s)	ed_addmulti(s)		/* ޥ㥹ȥɥ쥹Ͽ		*/

#if !defined(TOPPERS_MACRO_ONLY) && !defined(_MACRO_ONLY)

/*
 *  
 */

#ifndef T_IF_SOFTC_DEFINED

typedef struct t_if_softc T_IF_SOFTC;

#define T_IF_SOFTC_DEFINED

#endif	/* of #ifndef T_IF_SOFTC_DEFINED */

#ifndef T_NET_BUF_DEFINED

typedef struct t_net_buf T_NET_BUF;

#define T_NET_BUF_DEFINED

#endif	/* of #ifndef T_NET_BUF_DEFINED */

/*
 *  ؿ
 */

extern T_IF_SOFTC *ed_get_softc(void);
extern void ed_watchdog(T_IF_SOFTC *ic);
extern void ed_probe(T_IF_SOFTC *ic);
extern void ed_init(T_IF_SOFTC *ic);
extern void ed_reset(T_IF_SOFTC *ic);
extern T_NET_BUF *ed_read(T_IF_SOFTC *ic);
extern void ed_start(T_IF_SOFTC *ic, T_NET_BUF *output);
extern ER ed_addmulti(T_IF_SOFTC *ic);
extern void if_ed_handler(void);

#endif /* #if !defined(TOPPERS_MACRO_ONLY) && !defined(_MACRO_ONLY) */

#endif	/* of #ifndef _IF_ED_H_ */
